
define(dir, Hetris)
define(dotdot, .)

define(makefile, dir/Makefile)

haskell_modules_program(dir, haskell_with_ffi_th_compiler -lcurses -lwrap -I`'dir, dir)

dir/Curses.hs: dir/Curses.hsc makefile
	hsc2hs -o $@ $< -L -lcurses -I`'dir

dir/Hetris.dvi: dir/Makefile dir/Haskell2LaTeX.sty dir/ifmtarg.sty makefile

dir/%.doclet.tex: dir/%.lhs makefile
	Haskell2LaTeX < $< > $@

dir/%.doclet.tex: dir/%.alhs makefile
	Haskell2LaTeX < $< > $@

dir/Hetris.tex: dir/Makefile $(filter-out dir/Hetris.tex, $(wildcard dir/*.tex)) $(patsubst %.lhs, %.doclet.tex, $(wildcard dir/*.lhs)) $(patsubst %.alhs, %.doclet.tex, $(wildcard dir/*.alhs)) makefile
	cat dir/{Header.tex,Title.tex,Intro.tex,Terminology.tex,Plan.tex,Data.doclet.tex,AbstractPieces.doclet.tex,Pieces.doclet.tex,AbstractBoard.doclet.tex,Board.doclet.tex,AbstractUI.doclet.tex,UI.doclet.tex,Input.doclet.tex,Output.doclet.tex,Hetris.doclet.tex,Conclusion.tex,Footer.tex} > $@

clean::
	rm -f dir/{Curses.hs,Hetris.tex,Hetris-pp.tex,Hetris,*.o,*.hi,*.doclet.tex,Hetris.{log,toc,aux,dvi,ps,pdf},wrap.{c,h}}

